#!/usr/bin/python

"""

	MobileMail

	Takes a to, subject and text value posted via
	HTTP GET from forms in readmail.cgi and index.cgi
	and sends the mail via SMTP. Logs an entry in
	the syslog so you can check for tampering :D

"""

__author__ = "Robin Rawson-Tetley <robin@rawsontetley.org>"
__version__ = "1.0"
__license__ = "GPL"
__copyright__ = "Copyright(c)2005, Robin Rawson-Tetley"
__date__ = "20th April, 2005"

import os
import smtplib
import syslog
import string
import config

# Your name/address to stamp from
fr = config.replyaddress
to = "postmaster@yourdomain.org"
subject = "[No Subject]"
body = ""
smtphost = config.smtphost

print "Content-type: text/html"
print ""

# Extract the different bits from the query string
qs = os.environ['QUERY_STRING']
bits = qs.split('&')

for bit in bits:
	b = bit.split('=')
	if b[0] == "to":
		to = b[1]
	if b[0] == "subject":
		subject = b[1]
	if b[0] == "body":
		body = b[1]

# Expand % and +s
to = to.replace("%40", "@")
subject = subject.replace("+", " ")
body = body.replace("+", " ")
body = body.replace("%2C", ",")

# Construct the message
msg = "From: " + fr + "\r\nTo: " + to + "\r\nSubject: " + subject + "\r\n\r\n" + body

# Send the email
smtp = smtplib.SMTP()
smtp.connect(smtphost, 25)
smtp.sendmail( fr, to, msg)

# Log
syslog.syslog("WWWSEND: to=" + to + ", subject=" + subject)

# Disconnect
smtp.quit()

print "<html><body><h1>Mail Sent to " + to + "</h1>"
print "<p><a href='index.cgi'>back</a></p>"
#print "<pre>To: " + to + ", Subject: " + subject + " Body: " + body + "</pre>"
print "</body></html>"
