#!/usr/bin/python

"""
    MobileMail

    Reads an email - requires a filename in the
    querystring and assumes it contains the mail. It
    looks in the tmpdir for this file.

    The mail is parsed and the From/Subject lines
    are extracted and used to populate a form
    you can use to reply to the mail.

    25 Apr RRT - Better address parsing for my phone
    
"""

__author__ = "Robin Rawson-Tetley <robin@rawsontetley.org>"
__version__ = "1.01"
__license__ = "GPL"
__copyright__ = "Copyright(c)2005, Robin Rawson-Tetley"
__date__ = "25th April, 2005"

import mailbox
import os
import re
import syslog
import config

print "Content-type: text/html"
print ""
print "<html><body>"

# Grab the query string and log the reading of the message
# to the syslogger
qs = os.environ['QUERY_STRING']
syslog.syslog("WWWREAD: " + qs)

# Open the file
f = open(config.tmpdir + "/" + qs)

# Read the message from the file
msg = f.read()
f.close()

# Delete the cached file
# os.remove( config.tmpdir + "/" + qs)

# Link back to the main mail
print "<p><a href='index.cgi'>back</a></p>"

# Parse the from and subject lines from the mail so
# we can default them into the reply form
fr = ""
subject = ""
frompattern = re.compile("From:.*")
subjectpattern = re.compile("Subject:.*")
for i in frompattern.findall(msg):
    fr = i[6:len(i)]
    break
for i in subjectpattern.findall(msg):
    subject = "Re: %s" % i[9:len(i)]
    break

# If the from line has a proper name and an address in
# angle brackets, extract and just use the address as
# my phone can't handle the brackets in string literals
if fr.find("<") != -1:
    sp = fr.find("<") + 1
    ep = fr.find(">")
    fr = fr[sp:ep]

# A reply form
print "<form name='s1' id='s1' method='get' action='sendmail.cgi'><h1>Reply</h1>"
print "<p>To:<br/><input id='to' name='to' type='text' value='" + fr + "' /></p>"
print "<p>Subject:<br/><input id='subject' name='subject' type='text' value='" + subject + "'/></p>"
print "<p><textarea id='body' name='body'></textarea><br />"
print "<input type='submit' name='submit' value='Send'></p>"

print "<pre>"

# Output the mail contents
print msg
    
# And finish up
print "</pre>"
print "</body></html>"
